/*********************************************************************
	main.cpp
	
	This file contains the main routines for the replicat shell. All
	the app really is for is to export the kitten replicant.
	
	Who		When		What
	GJW		971022	Initial coding and commenting
	GJW		971024	Made window resizable
	GJW		980515	Cleaned up code and hopefully made it Intel-
					friendly.
	GJW		990110	Finally got an Intel box. Really cleaning up the
					code. Luckily, I missed the whole PE fiasco. Now
					have to make it compile nicely.
*********************************************************************/

//	Private Headers
#include <Application.h>
#include <MessageFilter.h>
#include "VuKitten.h"

//	Private Prototypes
filter_result f_quit(BMessage* ioMessage, BHandler** ioTarget, BMessageFilter* inFilter);


/*********************************************************************
	main
	Args:	<none>
	Returns:	<none>
	This is the main line of the replicat program. All we do is make
	an application, make a window, and add a kitten to the window.
	We also patch the event queue to make sure the app quits
	properly.
*********************************************************************/
int main(void)
{
	BApplication app("application/x-vnd.Bastion-replicat");
	BRect theRect(0,0,399,299);
	BWindow* win = new BWindow(theRect,"Replicat",B_TITLED_WINDOW,0);
	win->AddChild(new VuKitten(theRect));
	win->AddCommonFilter(new BMessageFilter(B_QUIT_REQUESTED,f_quit));
	win->MoveTo(75,50);
	win->Show();
	app.Run();
	return 0;
}


/*********************************************************************
	f_quit
	Args:	ioMessage - the message we have been asked to filter
			ioTarget - the handler that will receive the message
			inFilter - the messagefilter we are acting for
	Returns:	whether or not to dispatch the message
	This filter intercepts quit messages for the window and sends a
	message to the app to quit. We only have the one window, and
	according to the UI guidelines a (non-server) app without any
	open windows should close.
*********************************************************************/
filter_result f_quit(BMessage* /*ioMessage*/, BHandler** /*ioTarget*/, BMessageFilter* /*inFilter*/)
{
	be_app->PostMessage(B_QUIT_REQUESTED);
	return B_DISPATCH_MESSAGE;
}
